function [samples, fpred] = NonParSF2(target, data, data2, pred, cost, rstar, Mn0, Meta, Msd, burnin, thin, numbofits)

firm = data(:, size(data, 2));
data = data(:, 1:(size(data, 2)-1));

level = data2(:, size(data2, 2));
data2 = data2(:, 1:(size(data2, 2)-1));

[n p] = size(data);

numbfirms = max(firm);
numblevels = max(level);

for i = 1:numbfirms
    if ( sum(firm==i) == 0 )
        'Error in firm indices'
        exit(1)
    end
end

for i = 1:numblevels
    if ( sum(level==i) == 0)
        'Error in data2 vector'
    end
end

if ( numbfirms ~= size(data2, 1) )
    'Error in data2 matrix'
end

data = [ones(n, 1) data];
p = p + 1;
%data2 = [ones(numbfirms, 1) data2];
data2star = zeros(numblevels, size(data2, 2));
for i = 1:numbfirms
    data2star(level(i), :) = data2(i, :);
end

psi = ones(1, size(data2, 2));
psi(1) = - 1 / log(rstar);

lambda = zeros(numblevels, 1);
for i = 1:numblevels
    lambda(i) = prod(psi.^data2star(i, :));
end

s = (1:numbfirms)';
sstar = level;
numb = ones(numbfirms, 1);
u = - log(rand(max(s), 1)) ./ lambda(sstar);
M = 1;

lambda0 = 10^(-6);

xtx = data' * data;

holdsigmasq = zeros(numbofits, 1);
holdbeta = zeros(numbofits, p);
holdu = zeros(numbofits, numbfirms);
holdM = zeros(numbofits, 1);
holdgamma = zeros(numbofits, size(data2, 2));
fpred = zeros(numblevels, length(pred));

Maccept = 0;
Mcount = 0;

beta = inv(data' * data) * data' * target;
sigmasq = var(target -  data * beta);

totalits = burnin + thin * numbofits;

data2star

for it = 1:totalits

    % Updating beta
    varstar = inv(xtx + sigmasq * lambda0 * eye(p));
    xty = data' * (target - u(s(firm)));
    meanstar = varstar * xty;

    beta = meanstar + sqrt(sigmasq) * chol(varstar)' * randn(p, 1);

    lambdastar = 0;
    for i = 1:length(numb)
        lambdastar = lambdastar + lambda(sstar(i));
    end

    if ( cost == 1 )      
        alphastar = - log(rand) / lambdastar;
        minu = min(u);
        u = u - minu + alphastar;
        beta(1) = beta(1) + minu - alphastar;
    else
        oldbeta1 = beta(1);
        beta(1) = beta(1) - min(u) - log(rand) / lambdastar;
        u = u + beta(1) - oldbeta1;
    end
    
    % Updating s
    for i = 1:numbfirms
        numb(s(i)) = numb(s(i)) - 1;
        if ( numb(s(i)) == 0 )
            numb(s(i), :) = [];
            sstar(s(i), :) = [];
            u(s(i), :) = [];
            s = s - (s > s(i));
        end

        prob = zeros(1, length(numb) + 1);

        err = target(firm==i) - data(firm==i, :) * beta;
        nstar = sum(firm==i);
        if ( cost == 1 )
            for j = 1:length(numb)
                if ( sstar(j) == level(i) )
                    prob(j) = numb(j)*exp(- 0.5 * sum((err - u(j)).^2) / sigmasq);
                end
            end
            prob(length(numb)+1) = M*lambda(level(i))*sqrt(sigmasq/nstar)*exp(- 0.5 * (sum(err.^2) - (sum(err) - sigmasq * lambda(level(i)))^2/nstar) / sigmasq);
        else
            for j = 1:length(numb)
                if ( sstar(j) == level(i) )
                    prob(j) = numb(j)*exp(- 0.5 * sum((err + u(j)).^2) / sigmasq);
                end
            end
            prob(length(numb)+1) = M*lambda(level(i))*sqrt(sigmasq/nstar)*exp(- 0.5 * (sum(err.^2) - (sum(err) + sigmasq * lambda(level(i)))^2/nstar) / sigmasq);
        end
        
        fprob = cumsum(prob);
        fprob = fprob ./ fprob(end);

        ustar = rand;
        s(i) = 1;
        while ( fprob(s(i)) < ustar )
            s(i) = s(i) + 1;
        end

        if ( s(i) == length(u) + 1 )
            numb = [numb; 1];
            if ( cost == 1 )
                mustar = (sum(err) - sigmasq * lambda(level(i))) / nstar;
            else
                mustar = - (sum(err) + sigmasq * lambda(level(i))) / nstar;
            end
            varstar = sigmasq / nstar;
            newu = truncated_normal(mustar, varstar, 0, inf);
            u = [u; newu];
            sstar = [sstar; level(i)];
        else
            numb(s(i)) = numb(s(i)) + 1;
        end
    end

    % Updating u
    sum1 = zeros(length(numb), 1);
    sum2 = zeros(length(numb), 1);
    for i = 1:n
        sum1(s(firm(i))) = sum1(s(firm(i))) + target(i) - data(i, :) * beta;
        sum2(s(firm(i))) = sum2(s(firm(i))) + 1;
    end

    for i = 1:length(u)
        if ( cost == 1 )
            mustar = (sum1(i) - sigmasq * lambda(sstar(i))) / sum2(i);
        else
            mustar = - (sum1(i) + sigmasq * lambda(sstar(i))) / sum2(i);
        end
        varstar = sigmasq / sum2(i);
        u(i) = truncated_normal(mustar, varstar, 0, inf);
    end

    % Updating sigmasq
    if ( cost == 1 )
        sigmasq = 1 / gamrnd(0.001 + 0.5 * n, 1 / (0.001 + 0.5 * sum((target - u(s(firm)) - data * beta).^2)));
    else
        sigmasq = 1 / gamrnd(0.001 + 0.5 * n, 1 / (0.001 + 0.5 * sum((target + u(s(firm)) - data * beta).^2)));
    end
    
    % Updating gamma
    alphastar = 1 + length(u);
    betastar = - log(rstar);
    for i = 1:length(u)
        betastar = betastar + u(i)*prod(psi(2:size(data2,2)).^(data2star(sstar(i),2:size(data2, 2))));
    end
    psi(1) = gamrnd(alphastar, 1 / betastar);
    for j = 2:length(psi)
       alphastar = 1 + sum(data2star(sstar, j));
       betastar = 1;
       for i = 1:length(u)
           if ( data2star(sstar(i), j) == 1 )
               betastar = betastar + u(i)*prod(psi(1:(j-1)).^(data2star(sstar(i),1:(j-1)))).*prod(psi((j+1):end).^(data2star(sstar(i),(j+1):size(data2, 2))));
           end
       end
       psi(j) = gamrnd(alphastar, 1 / betastar);
    end

    for i = 1:numblevels
        lambda(i) = prod(psi.^data2star(i, :));
    end
    
    % Updating M
    newM = M * exp(Msd * randn);

    logaccept = length(numb) * log(newM) + gammaln(newM) - gammaln(newM + numbfirms);
    logaccept = logaccept - (length(numb) * log(M) + gammaln(M) - gammaln(M + numbfirms));
    logaccept = logaccept + Meta * log(newM) - 2 * Meta * log(newM + Mn0);
    logaccept = logaccept - (Meta * log(M) - 2 * Meta * log(M + Mn0));

    accept = 1;
    if ( logaccept < 0 )
        accept = exp(logaccept);
    end

    Maccept = Maccept + accept;
    Mcount = Mcount + 1;

    if ( rand < accept )
        M = newM;
    end

    if ( mod(it, 100) == 0 )
        it
        Maccept / Mcount
    end

    if ( (it > burnin) && (mod(it - burnin, thin) == 0))
        holdsigmasq((it - burnin) / thin) = sigmasq;
        holdbeta((it - burnin) / thin, :) = beta;
        holdu((it - burnin) / thin, :) = u(s);
        holdM((it - burnin) / thin) = M;
        holdgamma((it - burnin) / thin, :) = log(psi);
        for j = 1:numblevels
            lambdastar = prod(data2star(j, :).^psi);
            for i = 1:length(pred);
                fpred(j, i) = fpred(j, i) + sum(numb(u(sstar==j)<pred(i))) / (M + sum(level==j)) + M / (M + sum(level==j)) * (1 - exp(- lambdastar * pred(i)));
            end
        end
    end
end

fpred = fpred / numbofits;

samples = struct('u',holdu,'beta',holdbeta,'gamma',holdgamma,'sigmasq',holdsigmasq,'M',holdM);