function [prob] = quantile_plot(holdu)

[numbofits, numbfirms] = size(holdu);

prob = zeros(4, numbfirms);

Q1 = round(0.25 * numbfirms);
Q2 = round(0.5 * numbfirms);
Q3 = round(0.75 * numbfirms);

[z1, z2] = sort(holdu, 2);
for it = 1:numbofits
    prob(1, z2(it, 1:Q1)) = prob(1, z2(it, 1:Q1)) + 1;
    prob(2, z2(it, (Q1+1):Q2)) = prob(2, z2(it, (Q1+1):Q2)) + 1;
    prob(3, z2(it, (Q2+1):Q3)) = prob(3, z2(it, (Q2+1):Q3)) + 1;
    prob(4, z2(it, (Q3+1):end)) = prob(4, z2(it, (Q3+1):end)) + 1;
end
prob = prob / numbofits;

z = linspace(0,1,128);
colormap([z' z' z'])

bar(prob','stacked')