function [x] = trunc_norm(a, b)

if (b==inf)
   if (a>0.45)
       check = 0;
       lambda = a;
       while (check == 0)
           x = a - log(rand) / lambda;
           check = (rand<exp(-0.5*(x-lambda)^2));
       end
   else
      x = a - 1;
      while ( x < a )
          x = randn;
      end
   end
elseif ((a<=0)&(b>0))
    phia = exp(-0.5 * a^2) / sqrt(2 * pi);
    phib = exp(-0.5 * b^2) / sqrt(2 * pi);
    if (( phia > 0.15 ) || (phib > 0.15) )
        check = 0;
        while (check == 0)
            x = a + (b - a) * rand;
            check = rand<exp(-0.5*x^2);
        end
    else
        check = 0;
        x = a - 1;
        while ( (x<a) || (x>b) )
            x = randn;
        end
    end
elseif (a>0)
    ratio = exp(-0.5 * a^2) / exp(-0.5 * b^2);
    if (ratio < 2.18)
        check = 0;
        while (check == 0)
            x = a + (b - a) * rand;
            check = (rand<exp(-0.5*(x^2-a^2)));
        end
    elseif ( (ratio>2.18) & (a<0.725) )
        x = a - 1;
        while ((x<a)||(x>b))
            x = abs(randn);
        end
    else
        lambda = a;
        check = 0;
        while ( check == 0 )
            u = rand;
            x = a - log(u + (1 - u) * exp(- lambda * (b - a))) / lambda;
            check = (rand<exp(-0.5*(x-lambda)^2));
        end
    end
end